# -*- coding: utf-8 -*-
"""
Created on Wed Jan 24 13:31:39 2018

@author: af5u13
"""

import numpy as np
from scipy.special import lpmv

def maxReWeights3D( shOrder ):
    """ max Re weights as defined in Zotter and Frank 2012:
        "All-Round Ambisonic Panning and Decoding"
    """
    a = np.zeros((shOrder+1), dtype=np.double )
    arg = np.cos( (137.9*np.pi/180.0)/(1.51+shOrder) )
    for idx in range(0,shOrder+1):
        a[idx] = lpmv(0, idx, arg )
    return a