# -*- coding: utf-8 -*-
"""
Created on Tue Feb 14 15:59:11 2017

@author: af5u13
"""


import visr
import panning
import rrl
import objectmodel

from allrad_gain_calculator import AllRadGainCalculator

from helper.baseTrigFunctions import sph2cart
from helper.max_re_weights_3d import maxReWeights3D


import numpy as np;
import matplotlib.pyplot as plt

hfLfPanning = False

blockSize = 128
samplingFrequency = 48000

azGrid = np.arange( -180, 180, 1 ) * np.pi/180.0
gridSize = len( azGrid )

numSamples = 1024;
numObjectChannels = 1;

ctxt = visr.SignalFlowContext( blockSize, samplingFrequency)

# lc = panning.LoudspeakerArray( '/home/andi/dev/visr/config/isvr/audiolab_39speakers_1subwoofer.xml' )
# lc = panning.LoudspeakerArray( '/home/andi/dev/visr/config/generic/bs2051-9+10+3_linear.xml' )
# lc = panning.LoudspeakerArray( 'c:/local/visr/config/isvr/audiolab_39speakers_1subwoofer.xml' )
# lc = panning.LoudspeakerArray( 'c:/local/visr/config/generic/bs2051-9+10+3.xml' )
lc = panning.LoudspeakerArray( '../data/bs2051-4+5+0_mpeg-h_downmix.xml' )

numSpeakers = lc.numberOfRegularLoudspeakers

regularArray = panning.LoudspeakerArray( '../data/t-design_order11_n70.xml' )

hoaOrder = 3

# Whether to use plain Ambisonics decoding or max-re weights for the regular decoding part of AllRAD
#maxReWeights = maxReWeights3D( hoaOrder )
maxReWeights = None # No max-re weightings

calc = AllRadGainCalculator( ctxt, 'calc', None,
                                numberOfObjects=numObjectChannels,
                                regularArrayConfig=regularArray,
                                realArrayConfig = lc,
                                hoaOrder = hoaOrder,
                                orderWeights = maxReWeights )

flow = rrl.AudioSignalFlow( calc )

paramInput = flow.parameterReceivePort('objectVectorInput')

gainOutput = flow.parameterSendPort('gainOutput')

#paramInput = flow.parameterReceivePort('objectVectorInput')
#
#gainOutput = flow.parameterSendPort("gainOutput")
#
#paramInput = flow.parameterReceivePort('objects')
#
#gainOutput = flow.parameterSendPort("gains")

gains = np.zeros( (gridSize, numSpeakers ) )

for blockIdx in range(0,gridSize):
    az = azGrid[blockIdx]
    el = 15.0*np.pi/180.0
    r = 1
    x,y,z = sph2cart( az, el, r )
    ps1 = objectmodel.PointSource(0)
    ps1.x = x
    ps1.y = y
    ps1.z = z
    ps1.level = 1
    ps1.channels = [ps1.objectId]
    # Optional: Check channel lock feature,
    # ps1.channelLockDistance = 17.50 # maximum distance (in degree)

    ov = paramInput.data()
    ov.clear()
    ov.insert( ps1 )
    paramInput.swapBuffers()

    flow.process()

    gains[blockIdx,:] = np.ravel( np.array( gainOutput.data()  ) )


plt.figure()
# plt.subplot(121)
plt.plot( azGrid *180/np.pi, gains[:,0], 'b.-' )
plt.title( 'AllRAD gains' )
plt.xlabel( 'azimuth (deg)' )
#plt.subplot(122)
#plt.plot( azGrid *180/np.pi, lfGains )
#axes = plt.gca()
##axes.set_xlim([-45,45])
##axes.set_ylim([0,0.9])
#plt.title( 'LF gains' )
#plt.xlabel( 'azimuth (deg)' )
#axes = plt.gca()
#axes.set_xlim([-45,45])
#axes.set_ylim([0,0.9])
plt.show()
