# -*- coding: utf-8 -*-
"""
Created on Tue Feb 14 15:59:11 2017

@author: af5u13
"""

#exec(open("/home/andi/dev/visr/src/python/scripts/testPanningCalculator.py").read())


import visr
import rcl
import panning
import pml
import rrl
import objectmodel

from allrad_panner import AllRadPanner

import numpy as np;
import matplotlib.pyplot as plt

def sph2cart(az,el,r):
    x = r*np.cos(az)*np.cos(el)
    y = r*np.sin(az)*np.cos(el)
    z = r*np.sin(el)
    return x,y,z

hfLfPanning = False

blockSize = 128
samplingFrequency = 48000

numBlocks = 256;
signalLength = blockSize * numBlocks
numObjectChannels = 1;

ctxt = visr.SignalFlowContext( blockSize, samplingFrequency)

regularArray = panning.LoudspeakerArray( '../data/t-design_order11_n70.xml' )

lc = panning.LoudspeakerArray( '../data/bs2051_4+5+0.xml' )

numSpeakers = lc.numberOfRegularLoudspeakers

renderer = AllRadPanner( ctxt, 'calc', None,
                        numberOfInputs=numObjectChannels,
                        regularArrayConfig=regularArray,
                        realArrayConfig = lc,
                        interpolationSteps=0, # blockSize,
                        hoaOrder = 5 )

flow = rrl.AudioSignalFlow( renderer )


paramInput = flow.parameterReceivePort('objects')

# Dummy input required for the process() function
inputSignal = np.zeros( (numObjectChannels, signalLength ), dtype=np.float32 )
inputSignal[0,:] = 1.0

outputSignal = np.zeros( (numSpeakers, signalLength ), dtype=np.float32 )

for blockIdx in range(0,numBlocks):
    # 2 complete circles
    az = 2.0 * float(blockIdx)*2.0*np.pi/float(numBlocks)
    el = 30.0/180.0*np.pi
    r = 1
    x,y,z = sph2cart( az, el, r )
    ps1 = objectmodel.PointSource(0)
    ps1.x = x
    ps1.y = y
    ps1.z = z
    ps1.level = 1
    ps1.channels = [ps1.objectId]
    # Optional: Check channel lock feature,
    # ps1.channelLockDistance = 17.50 # maximum distance (in degree)

    ov = paramInput.data()
    ov.clear()
    ov.insert( ps1 )
    paramInput.swapBuffers()

    outputSignal[:,(blockIdx*blockSize):((blockIdx+1)*blockSize)] = flow.process( inputSignal[:,(blockIdx*blockSize):((blockIdx+1)*blockSize)] )

t = np.arange(signalLength)/samplingFrequency

plt.figure(1)
plt.plot( t, outputSignal[0,:], 'b.-' )

#plt.figure(1)
#plt.subplot(121)
#plt.plot( azGrid *180/np.pi, hfGains, 'b.-' )
#plt.title( 'HF gains' )
#plt.xlabel( 'azimuth (deg)' )
#plt.subplot(122)
#plt.plot( azGrid *180/np.pi, lfGains )
#axes = plt.gca()
#axes.set_xlim([-45,45])
#axes.set_ylim([0,0.9])
#plt.title( 'LF gains' )
#plt.xlabel( 'azimuth (deg)' )
#axes = plt.gca()
#axes.set_xlim([-45,45])
#axes.set_ylim([0,0.9])
#plt.show()
